/* Copyright (C) 2014-2015 Dan Chapman <dpniel@ubuntu.com>

   This file is part of Dekko email client for Ubuntu Devices/

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation; either version 2 of
   the License or (at your option) version 3

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
import QtQuick 2.0
import Ubuntu.Components 1.1
import Ubuntu.Components.Popups 1.0
import "../Components"
import "../Dialogs"

PageHeadConfiguration {
    id: topContainer

    // Signals
    signal sendClicked
    signal cancelClicked
    signal loseFocus
    signal draftsClicked

    Action {
        id: draftsAction
        text: qsTr("Drafts")
        onTriggered: {
            draftsClicked()
        }
        iconName: "edit"
    }

    Action {
        id: sendAction
        text: qsTr("Send")
        onTriggered: {
            sendClicked()
        }

        iconSource: Qt.resolvedUrl("../../icons/actions/sent.svg")
    }

    Action {
        id: closeAction
        text: qsTr("Cancel")
        onTriggered: {
            cancelClicked()
        }
        iconName: "close"
    }

    backAction: closeAction
    actions: [
        sendAction,
        draftsAction
    ]
}
